#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

constexpr int MAXN = 100000;

int n, m;

vector<pair<int, int>> G[MAXN];
bool V1[MAXN], V2[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int u, v, d;
        cin >> u >> v >> d;
        G[u].push_back({d, v});
        G[v].push_back({d, u});
    }
    
    priority_queue<pair<int, int>> pq;
    pq.push({0, 0});

    int t1 = -1, t2 = -1;

    while (!pq.empty()) {
        int u = pq.top().second;
        int t = -pq.top().first;
        pq.pop();
        if (V1[u]) continue;
        V1[u] = true;

        if (u == n-1) {
            t1 = t;
            break;
        }

        for (auto e : G[u]) {
            int sleep = t % 24 + e.first > 12 ? 12 : 0;
            pq.push({-t-e.first-sleep, e.second});
        }
    }

    pq = {};
    pq.push({0, 0});

    while (!pq.empty()) {
        int u = pq.top().second;
        int t = -pq.top().first;
        pq.pop();
        if (V2[u]) continue;
        if (u == n-1) {
            t2 = t;
            break;
        }
        V2[u] = true;
        
        for (auto e : G[u]) {
            if (t % 24 + e.first <= 12)
                pq.push({-t-e.first, e.second});
            else {
                int wait = 24 - t % 24;
                pq.push({-t-e.first - wait, e.second});
            }
        }
    }

    cout << t2 - t1 << endl;
}
