#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <climits>
#include <cfloat>
#include <set>
#include <map>
#include <queue>
#include <stdexcept>
#include <iomanip>

using namespace std;

// Shortcuts for common data types
typedef long long          LL;
typedef unsigned long long ULL;
typedef long double        LD;
typedef pair<int, int>     pii;
typedef vector<pii>        vii;
typedef vector<int>        vi;

// Various
#define rep(i,n) for(int i=0;i<(n);i++)
#define foreach(i, a) for(__typeof(a.begin()) i = a.begin(); i != a.end(); i++)
#define feq(x,y) (fabs(x-y) <= DBL_EPSILON)
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

// Bit operations
#define set_bit(x, i) (x) |= (1 << (i))
#define clr_bit(x, i) (x) & ~(1 << (i))
#define tog_bit(x, i) (x) ^= (1 << (i))
#define chk_bit(x, i) (((x) >> (i)) & 1)

// Quick scanning
#define sf(n)       scanf("%d", &n)
#define sff(a,b)    scanf("%d %d", &a, &b)
#define sfff(a,b,c) scanf("%d %d %d", &a, &b, &c)

// Useful constants
#define MOD 1000000007
#define INF ((int) 1e9)
#define EPS 1e-9
#define MAXN 100000
#define MAXM 100000
#define u 0
#define v 1
#define w 2

// Shortcuts for pair
#define x first
#define y second

// Debugging
#define DBUG(x)    std::cout<<#x<<" is "<<x<<"\n"

int n, m;
int dist[MAXN];
int edges[MAXM][3];

int main() {
    std::ios::sync_with_stdio(false); // Speedup (do not mix with scanf/prinf)
    std::cin.tie(NULL); // Speedup (do not mix with scanf/prinf)
    std::cout << std::fixed; std::cout << std::setprecision(2); //print as 1.23
    
    cin >> n >> m;
    rep(i, m) cin >> edges[i][u] >> edges[i][v] >> edges[i][w];
    
    // Olsen
    rep(i, n) dist[i] = INF;
    dist[0] = 0;
    
    bool change = true;
    while (change) {
        change = false;
        rep(i, m) {
            if (dist[edges[i][u]] + edges[i][w] < dist[edges[i][v]]) {
                change = true;
                dist[edges[i][v]] = dist[edges[i][u]] + edges[i][w];
            }
            if (dist[edges[i][v]] + edges[i][w] < dist[edges[i][u]]) {
                change = true;
                dist[edges[i][u]] = dist[edges[i][v]] + edges[i][w];
            }
        }
    }
    
    int olsenTime = 12 * ((dist[n-1]-1)/12) + dist[n-1];
    
    // Larsen
    rep(i, n) dist[i] = INF;    
    dist[0] = 0;
    
    change = true;
    while (change) {
        change = false;
        rep(i, m) {
            if (edges[i][w] > 12) continue;
            rep(j, 2) {
                int from = edges[i][u+j];
                int to = edges[i][v-j];
                int weight = edges[i][w];
            
                int daysFrom = dist[from] / 24;
                int hoursFrom = dist[from] % 24;
                int daysTo = dist[to] / 24;
                int hoursTo = dist[to] % 24;
                
                int nextDay = (weight + hoursFrom) > 12 ? 1 : 0;
                int proposalDay = daysFrom + nextDay;
                int proposalHour = nextDay ? weight : hoursFrom + weight;
            
                if (proposalDay < daysTo || (proposalDay <= daysTo && proposalHour < hoursTo)) {
                    change = true;
                    dist[to] = 24*proposalDay + proposalHour;
                } 
            }
        }
    }    

    // cout << olsenTime << endl;
    cout << (dist[n-1] - olsenTime) << endl;
    
    return 0;
}
