#!/usr/bin/python3

import argparse
import sys
import random

def main():
    parser = argparse.ArgumentParser(description="Generator for server three-satisfactory.")
    parser.add_argument('-o', metavar='O', type=str, default="",
                        help='Options for generation')
    parser.add_argument('-n', metavar='N', type=int, default=4)
    parser.add_argument('-m', metavar='M', type=int, default=6)
    parser.add_argument('-s', metavar='S', type=int, default=None,
                        help='seed for generation (optional)')
    args = parser.parse_args()
    random.seed(args.s)

    n = args.n
    m = args.m

    clauses = set()
    while len(clauses) < n:
        x = random.randint(-m, m)
        y = random.randint(-m, m)
        z = random.randint(-m, m)
        if x * y * z == 0 or x == y or y == z or x == z:
            continue
        clauses.add((x, y, z))
    print("%d %d" % (n, m))
    for clause in clauses:
        print("%d %d %d" % clause)

if __name__ == '__main__':
    main()
