#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <climits>
#include <cfloat>
#include <set>
#include <map>
#include <queue>
#include <stdexcept>
#include <iomanip>

using namespace std;

// Shortcuts for common data types
typedef long long          LL;
typedef unsigned long long ULL;
typedef long double        LD;
typedef pair<int, int>     pii;
typedef vector<pii>        vii;
typedef vector<int>        vi;

// Various
#define rep(i,n) for(int i=0;i<(n);i++)
#define foreach(i, a) for(__typeof(a.begin()) i = a.begin(); i != a.end(); i++)
#define feq(x,y) (fabs(x-y) <= DBL_EPSILON)
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

// Bit operations
#define set_bit(x, i) (x) |= (1 << (i))
#define clr_bit(x, i) (x) & ~(1 << (i))
#define tog_bit(x, i) (x) ^= (1 << (i))
#define chk_bit(x, i) (((x) >> (i)) & 1)

// Quick scanning
#define sf(n)       scanf("%d", &n)
#define sff(a,b)    scanf("%d %d", &a, &b)
#define sfff(a,b,c) scanf("%d %d %d", &a, &b, &c)

// Useful constants
#define MOD 1000000007
#define INF ((int) 1e9)
#define EPS 1e-9

// Shortcuts for pair
#define x first
#define y second

// Debugging
#define DBUG(x)    std::cout<<#x<<" is "<<x<<"\n"

int d, t, c, r;
bool noroof[1002];
double expect[10002];
double dp[1002][10002];

int main() {
    std::ios::sync_with_stdio(false); // Speedup (do not mix with scanf/prinf)
    std::cin.tie(NULL); // Speedup (do not mix with scanf/prinf)
    std::cout << std::fixed; std::cout << std::setprecision(7); //print as 1.23

    cin >> d >> t >> c >> r;
    rep(i, c) {
        int s, e;
        double p, a;
        cin >> s >> e >> p >> a;
        double addexp = p*a;
        for (int j=s; j<e; j++) expect[j] += addexp;
    }

    rep(i, r) {
        int x, y;
        cin >> x >> y;
        for (int j=x+1; j<=y; j++) noroof[j] = 1;
    }
    noroof[0] = 1;
    rep(i, d+2) noroof[i] = 1 - noroof[i];
    
    // cout << "d=" << d << "  t=" << t << endl;
    //
    // cout << "expect" << endl;
    // rep(i, t+1) cout << expect[i] << " ";
    // cout << "" << endl;

    // cout << "rfPrefix" << endl;
    // rep(i, d+2) cout << rfPrefix[i] << " ";
    // cout << "" << endl;
    //
    // cout << "roof" << endl;
    // rep(i, d+2) cout << noroof[i] << " ";
    // cout << "" << endl;
    
    rep(i, d+2) rep(j, t+2) dp[i][j] = INFINITY;
    // rep(i, d+1) dp[i][0] = 0.0;
    rep(j, t+2) dp[0][j] = 0.0;
    
    for (int here = 1; here <= d+1; here++) {
        for (int now = 1; now <= t+1; now++) {
            double move = dp[here-1][now-1] + (noroof[here] * expect[now-1]);
            double stay = dp[here][now-1] + (min(noroof[here], noroof[here+1]) * expect[now-1]);
            dp[here][now] = min(move, stay);
        }
    }

    //
    // rep(j, t+2) {
    //     cout << "time" << j << "  ";
    //     rep(i, d+2) {
    //         if (dp[i][j] == INFINITY) cout << "       ";
    //         else if (dp[i][j] < 10) cout << " ";
    //         cout << dp[i][j] << " ";
    //     }
    //     cout << endl;
    // }
    //
    cout << dp[d][t] << endl;
    
    return 0;
}
