from __future__ import absolute_import, division, print_function
import sys


def main():
    d, t, c, r = (int(x) for x in sys.stdin.readline().split())
    
    rain = [0] * (t + 1)
    for _ in xrange(c):
        start, stop, prob, amount = sys.stdin.readline().split()
        start = int(start)
        stop = int(stop)
        prob = float(prob)
        amount = int(amount)
        for i in xrange(start, stop):
            rain[i] += prob * amount
    
    roofed = [False] * (d + 1)

    # some roofs
    for _ in xrange(r):
        start, stop = (int(x) for x in sys.stdin.readline().split())
        for i in xrange(start, stop):
            roofed[i] = True

    # some parts of the distance is under roofs
    dp = [[float("inf")] * (t + 1) for _ in xrange(d + 1)]
    
    for i in xrange(t + 1):
        dp[0][i] = 0.0

    for j in xrange(1, t + 1):
        for i in xrange(1, min(j + 1, d + 1)):
            walked = dp[i - 1][j - 1] + (rain[j - 1] if not roofed[i - 1] else 0)
            waited = dp[i][j - 1] + (rain[j - 1] if not roofed[i] else 0)
            dp[i][j] = min(walked, waited)

    print(dp[d][t])

if __name__ == '__main__':
    main()
