import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class SlowSweep {

    public static void main(String args[]) throws Exception {
        Input in = new Input();
        int n = in.nextInt();
        ArrayList<RectSide> rectangles = new ArrayList<>();

        for (int i = 0; i < n; i++){
            long x0 = in.nextInt();
            long y0 =in.nextInt();
            long x1 = in.nextInt();
            long y1 = in.nextInt();
            
            rectangles.add(new RectSide(y0, y1, x0, true, i));
            rectangles.add(new RectSide(y0, y1, x1, false, i));
        }
        
        Collections.sort(rectangles);
        TreeSet<Tuple> sides = new TreeSet<>();
        long totalarea = 0;
        long prevX = 0;
        for (RectSide rect: rectangles){
            int covered = 0;
            long prevY = 0;
            long totalsegments = 0;
            for (Tuple t: sides){
                if (covered > 0) totalsegments += t.value - prevY;
                prevY = t.value;
                if (t.add) covered++;
                else covered--;
            }
            totalarea += totalsegments*(rect.x_value - prevX);
            prevX = rect.x_value;
            if (rect.leftSide){
                sides.add(rect.enter);
                sides.add(rect.exit);
            }
            else {
                sides.remove(rect.enter);
                sides.remove(rect.exit);
            }
        }
        
        System.out.println(totalarea);
    }
    
    static class Tuple implements Comparable<Tuple>{
        long value, id;
        boolean add;
        
        Tuple(long value, boolean add, long id){
            this.value = value;
            this.id = id;
            this.add = add;
        }
        
        public int compareTo(Tuple t){
            int ans =  (int) this.value - (int) t.value;
            return (ans != 0 ? ans : (int) this.id - (int) t.id);
        }
    }

    static class RectSide implements Comparable<RectSide>{
        long low, high;
        long x_value;
        boolean leftSide;
        long id;
        Tuple enter, exit;

        RectSide(long l, long h, long x, boolean left, long id){
            low = l;
            high = h;
            x_value = x;
            leftSide = left;
            this.id = id;
            enter = new Tuple(l, true, id);
            exit = new Tuple(h, false, id);
        }

        public int compareTo(RectSide r){
            return (int) x_value - (int) r.x_value;
        }
    }

    static class Input{
        StringTokenizer st;
        BufferedReader br;

        Input(){
            st = new StringTokenizer("");
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        int nextInt() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Integer.parseInt(st.nextToken());
        }

        long nextLong() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Long.parseLong(st.nextToken());
        }

        double nextDouble() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Double.parseDouble(st.nextToken());
        }

        String nextToken() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return st.nextToken();
        }
    }
}
