#!usr/bin/python3
from random import randint as ri
import random
import string

class Trie(object):
    def __init__(self):
        self.present = False;
        self.next = [];

def inbounds(y,x):
    return y < H and y > -1 and x < W and x > -1

#builds the trie
def buildfs(i, j, depth, p):
    if depth > L:
        return
    V[i][j] = True
    c = G[i][j]
    ni = [i+1,i-1,i,i]
    nj = [j,j,j+1,j-1]
    p = p.next[ord(c)-ord('A')]
    if not p.present:
        p.present = True
        p.next = [Trie() for _ in range(26)]
    for k in range(4):
        if inbounds(ni[k], nj[k]) and not V[ni[k]][nj[k]]:
            buildfs(ni[k], nj[k], depth+1, p)
    V[i][j] = False

#function to traverse the trie in a random fashion and build one word in the trie
def build_word(l):
    curr_trie = root
    w = ''
    sly, slx = [ri(0,H-1), ri(0,W-1)]
    w += G[sly][slx]
    curr_trie = root.next[ord(w[-1])-ord('A')]
    while len(w) != l and (True in [curr_trie.next[i].present for i in range(26)]):
        valid_directions = [i for i, e in enumerate(curr_trie.next) if e.present == True]
        di = random.choice(valid_directions)
        w += (chr(ord('A')+di))
        curr_trie = curr_trie.next[di] 
    return w


#Height, Width, Number of words, Max length of an individual word
H = ri(1,10)
W = ri(1,10)
N = ri(H*W, int((H*W)**2.5))
L = ri(min(H,W),max(H,W))
#uncomment for worstcase
#H = 10
#W = 10
#N = 100000
#L = 10

#Grid
G = []
for i in range(H):
    G.append(''.join([random.choice(string.ascii_uppercase) for _ in range(W)]))

#Visited for the builDFS
V = [[False for _ in range(W)] for _ in range(H)]
#Trieroot
root = Trie()
root.present = True
root.next = [Trie() for _ in range(26)]
#building the trie
for i in range(H):
    for j in range(W):
        buildfs(i,j,1,root)

# Using set to guarantee unique words 
words = set([build_word(ri(1,L)) for _ in range(ri(N//2,N))])
while len(words) != N:
    words.add(''.join([random.choice(string.ascii_uppercase) for _ in range(ri(1,L))]))
words = list(words)
random.shuffle(words)

#print results
print(H,W)
for s in G:
    print(s)
print(N,L)
for word in words:
    print(word)
