#include <iostream>
#include <vector>
int W, H, N, L = 10;
std::vector<std::string> words;
std::vector<std::string> G;
std::vector<std::vector<bool> > V;

struct trie{
	bool present = false;
	std::vector<trie> next;
};

trie root;

bool inbounds(int y, int x){
	return y > -1 && y < H && x > -1 && x < W;
}

void buildfs(int i, int j, int depth, trie* p){
	if(depth > L)
		return;
	V[i][j] = true;				//"unravel"
	const char &c = G[i][j];
	int ni[] = {i+1, i-1, i, i}; // CURRENT PRESUMPTION:
	int nj[] = {j, j, j+1, j-1}; // ONLY UP DOWN LEFT RIGHT, easily changeable
	p = &(p->next[c - 'A']);
	if(!p->present){
		p->present = true;
		p->next.assign(26, trie());
	}
	for(int k = 0; k < 4; k++){
		if(inbounds(ni[k], nj[k]) && !V[ni[k]][nj[k]])
			buildfs(ni[k], nj[k], depth + 1, p);
	}
	V[i][j] = false;			//"roll back up"
}

int main(){
	std::ios::sync_with_stdio(false);
	std::cin.tie(NULL);
	
	// setup/reading input
	std::cin >> H >> W;
	G.resize(H);
	V.assign(H, std::vector<bool>(W,false));
	root.present = true; root.next.assign(26,trie());
	for(int i = 0; i < H; i++)
		std::cin >> G[i];
	std::cin >> N;
	words.resize(N);
	for(int i = 0; i < N; i++)
		std::cin >> words[i];

	// trie construction
	for(int i = 0; i < H; i++)
		for(int j = 0; j < W; j++)
			buildfs(i, j, 1, &root);
	
	// counting existence in trie
	int count = 0;
	for(const std::string &s : words){
		bool e = true;
		trie* p = &root;
		for(const char &c : s){
			if(!p->next[c - 'A'].present){
				e = false;
				break;
			}
			p = &(p->next[c - 'A']);
		}
		if(e)
			count++;
	}
	std::cout << count << std::endl;
	return 0;
}
