#!usr/env python3
import collections
h, w = [int(i) for i in input().split()]
grid = [[] for _ in range(h)]
for i in range(h):
    grid[i] = list(input())

n = int(input())
words = [input() for _ in range(n)]


class TrieNode:
    def __init__(self):
        self.children = collections.defaultdict(TrieNode)


class Trie:
    def __init__(self):
        self.root = TrieNode()

    def insert(self, word):
        node = self.root
        for ch in word:
            node = node.children[ch]

    def search(self, word):
        node = self.root
        for ch in word:
            node = node.children.get(ch)
            if not node:
                return False
        return True


trie = Trie()


def neigh(i, j):
    res = [(i - 1, j), (i + 1, j), (i, j + 1), (i, j - 1)]
    res = [(_h, _w) for _h, _w in res if 0 <= _h < h and 0 <= _w < w]
    return res


def dfs(i, j, depth, visited, word):
    if depth >= 10 or visited[i][j]:
        return
    visited[i][j] = True
    word += grid[i][j]
    trie.insert(word)
    for ni, nj in neigh(i, j):
        if not visited[ni][nj]:
            dfs(ni, nj, depth + 1, visited, word)
    visited[i][j] = False
    return


for _i in range(h):
    for _j in range(w):
        dfs(_i, _j, 0, [[False for _ in range(w + 1)] for _ in range(h + 1)], "")

print(sum(trie.search(w) for w in words))
