from __future__ import absolute_import, division, print_function
import sys

def valid(x, y, grid):
    return 0 <= x < len(grid) and 0 <= y < len(grid[0])

visited = [[False] * 10 for _ in xrange(10)]

def search(grid, i, j, w):
    if len(w) == 0:
        return True
    if not valid(i, j, grid) or visited[i][j] or grid[i][j] != w[0]:
        return False
    visited[i][j] = True

    next_w = w[1:]
    ok = any(search(grid, next_i, next_j, next_w) for next_i, next_j in [(i - 1, j), (i, j - 1), (i + 1, j), (i, j + 1)])
    visited[i][j] = False
    return ok

def main():
    h, w = (int(x) for x in sys.stdin.readline().split())
    grid = [[x for x in sys.stdin.readline().strip()] for _ in xrange(h)]
    n = int(sys.stdin.readline())
    
    count = 0
    for _ in xrange(n):
        word = sys.stdin.readline().strip()
        found = False
        for i in xrange(h):
            if found: break
            for j in xrange(w):
                if search(grid, i, j, word):
                    found = True
                    count += 1
                    break

    print(count)


if __name__ == '__main__':
    main()
