#!/bin/bash

# Set the problem name to generate correct file names
PROBLEMNAME="ispmerger"

# Set this if you want to generate answers.
cp submissions/accepted/formula.py /tmp/solve.py
SOLVER="python /tmp/solve.py"

subfolders=(data/secret)
for i in ${subfolders[@]}
do
    rm -r $i
    if [ ! -d $i ]
    then
        mkdir $i
    fi
done


echo "Generating..."
DR="data/secret"

./generator.py -s 1 -n 500 -m 500 -t 4 -z 10 > $DR/01_randomtiny.in
./generator.py -s 2 -n 500 -m 500 -t 4 -z 10 > $DR/02_randomtiny.in
./generator.py -s 3 -n 500 -m 500 -t 4 -z 10 --no-budget-ok > $DR/03_randomtiny.in
./generator.py -s 4 -n 500 -m 300 -t 4 -z 10 --no-constraints-ok > $DR/04_randomtiny.in

./generator.py -s 5 -n 5000 -m 7000 -t 70 -z 300 > $DR/05_randomsmall.in
./generator.py -s 6 -n 5000 -m 7000 -t 70 -z 300 > $DR/06_randomsmall.in
./generator.py -s 7 -n 5000 -m 7000 -t 70 -z 300 --no-budget-ok > $DR/07_randomsmall.in
./generator.py -s 8 -n 5000 -m 3000 -t 70 -z 300 --no-constraints-ok > $DR/08_randomsmall.in

./generator.py -s 9 -n 25000 -m 35000 -t 300 -z 900 > $DR/09_randommedium.in
./generator.py -s 10 -n 25000 -m 15000 -t 300 -z 900 > $DR/10_randommedium.in
./generator.py -s 11 -n 25000 -m 35000 -t 300 -z 900 --no-budget-ok > $DR/11_randommedium.in
./generator.py -s 12 -n 25000 -m 15000 -t 300 -z 900 --no-constraints-ok > $DR/12_randommedium.in

./generator.py -s 13 -n 25000 -m 35000 -t 300 -z 900 > $DR/13_randommedium.in
./generator.py -s 14 -n 25000 -m 15000 -t 300 -z 900 > $DR/14_randommedium.in
./generator.py -s 15 -n 25000 -m 35000 -t 300 -z 900 --no-budget-ok > $DR/15_randommedium.in
./generator.py -s 16 -n 25000 -m 15000 -t 300 -z 900 --no-constraints-ok > $DR/16_randommedium.in

./generator.py -s 17 -n 90000 -m 150000 -t 1000 -z 3000 > $DR/17_randombig.in
./generator.py -s 18 -n 90000 -m 50000 -t 1000 -z 3000 > $DR/18_randombig.in
./generator.py -s 19 -n 90000 -m 150000 -t 1000 -z 3000 --no-budget-ok > $DR/19_randombig.in
./generator.py -s 20 -n 90000 -m 50000 -t 1000 -z 3000 --no-constraints-ok > $DR/20_randombig.in

./generator.py -s 21 -n 60000 -m 150000 -t 2000 -z 50000 > $DR/21_randombigmanytrees.in
./generator.py -s 22 -n 60000 -m 50000 -t 2000 -z 50000 > $DR/22_randombigmanytrees.in
./generator.py -s 23 -n 60000 -m 150000 -t 2000 -z 50000 --no-budget-ok > $DR/23_randombigmanytrees.in
./generator.py -s 24 -n 60000 -m 50000 -t 2000 -z 50000 --no-constraints-ok > $DR/24_randombigmanytrees.in


# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for i in ${subfolders[@]}
    do
        for f in $i/*.in
        do
            echo "solving $f"
            $SOLVER < $f > ${f%???}.ans
        done
    done
fi
