from __future__ import absolute_import, division, print_function
import re
import sys


def main():
    INTEGER_REGEX = "(?:0|[1-9][0-9]*)"
    FIRST_LINE_REGEX = " ".join([INTEGER_REGEX] * 3) + "\\n"
    line1 = sys.stdin.readline()
    assert re.match(FIRST_LINE_REGEX, line1)
    n, m, k = (int(x) for x in line1.split())
    assert 1 <= n <= 100000
    assert 0 <= m <= 200000
    assert 0 <= k <= 50000

    # sorry for strange way of doing a regex but otherwise python hangs on recursion
    CONSTRAINT_REGEX = "(?:0|[1-9][0-9]* )" + ("{%d}" % (n - 1)) + INTEGER_REGEX + "\\n"
    line2 = sys.stdin.readline()
    assert re.match(CONSTRAINT_REGEX, line2)
    constraints = [int(x) for x in line2.split()]
    assert len(constraints) == n
    assert all(map(lambda x: x > 0, constraints)) # ensure all address books have room

    adj = [[] for _ in xrange(n)]

    EDGE_REGEX = " ".join([INTEGER_REGEX] * 2) + "\\n"
    edges = set()
    for _ in xrange(m):
        edge_line = sys.stdin.readline()
        assert re.match(EDGE_REGEX, edge_line)
        u, v = (int(x) for x in edge_line.split())
        assert 0 <= u < n
        assert 0 <= v < n
        assert u != v
        if u > v:
            u, v = v, u
        adj[u].append(v)
        adj[v].append(u)
        edges.add((u, v))
    
    for i in xrange(n):
        assert len(adj[i]) <= constraints[i] # no violated constraints

    assert len(edges) == m # no duplicate edges
    last_line = sys.stdin.readline()
    assert len(last_line) == 0
    sys.exit(42)


if __name__ == '__main__':
    main()
