#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

struct component {
    int s;
    int e;
    int c;

    component() = default;

    bool operator< (const component &other) const {
        if (c == 1 && s == 1)
            return true;
        if (other.c == 1 && other.s == 1)
            return false;
        if (c == other.c)
            return e < other.e;
        return c < other.c;
    }
};

constexpr int MAXN = 100000;

int n, m, k, C[MAXN];
vector<int> G[MAXN];
bool V[MAXN];

void buildComponent(int u, component &comp) {
    if (V[u]) return;
    V[u] = true;

    comp.s++;
    comp.c += C[u]; // - G[u].size();
    comp.e += G[u].size();
    for (int v : G[u]) {
        comp.c--;
        if (V[v]) continue;
        buildComponent(v, comp);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        cin >> C[i];

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    priority_queue<component> comps;
    for (int i = 0; i < n; i++) if (!V[i]) {
        component comp = {};
        buildComponent(i, comp);
        comp.e /= 2;
        comp.e -= comp.s-1;

        if (comp.s == 2 && comp.e == 0 && comp.c == 0 && (i+2 < n || comps.size() > 0)) {
            k--;
            comp.s = 1;
            comp.c++;
            comps.push(comp);
            comps.push(comp);
            continue;
        }
        comps.push(comp);
    }

    while(comps.size() > 1 && k > 0) {
        auto a = comps.top();
        comps.pop();
        auto b = comps.top();
        comps.pop();

        if (a.c > 0 && b.c > 0) {
            a.c += b.c-2;
            a.e += b.e;
            a.s += b.s;
            comps.push(a);
            k--;
        }
        else if ((a.c > 0 && b.e > 0) || (a.e > 0 && b.c > 0)) {
            a.c += b.c;
            a.e += b.e-1;
            a.s += b.s;
            comps.push(a);
            k -= 2;
        }
        else if (a.e > 0 && b.e > 0) {
            a.c += b.c+2;
            a.e += b.e-2;
            a.s += b.s;
            comps.push(a);
            k -= 3;
        }
        else if (a.e > 0 || b.e > 0) {
            a.c += b.c;
            a.e += b.e-2;
            a.s += b.s;
            comps.push(a);
            k -= 4;
        }
        else break;
    }

    if (comps.size() == 1 && k >= 0) 
        cout << "yes" << endl;
    else
        cout << "no" << endl;
    
    
}
