from __future__ import absolute_import, division, print_function
import sys


def find_cc_caps(adj, constraints):
    n = len(adj)
    visited = [False] * n
    ccs = []
    for i in xrange(n):
        if visited[i]:
            continue
        stack = [i]
        comp_free = 0
        comp_edges = 0
        comp_size = 0
        while len(stack) > 0:
            u = stack.pop()
            if visited[u]:
                continue
            visited[u] = True
            comp_size += 1
            comp_edges += len(adj[u])
            comp_free += constraints[u] - len(adj[u])
            for v in adj[u]:
                if not visited[v]:
                    stack.append(v)
        comp_edges /= 2
        ccs.append((comp_free, comp_free + 2 * (comp_edges - comp_size + 1)))
    return ccs


def main():
    n, m, k = (int(x) for x in sys.stdin.readline().split())
    constraints = [int(x) for x in sys.stdin.readline().split()]

    adj = [[] for _ in xrange(n)]
    for _ in xrange(m):
        u, v = (int(x) for x in sys.stdin.readline().split())
        adj[u].append(v)
        adj[v].append(u)
    
    ccs = find_cc_caps(adj, constraints)

    if len(ccs) == 1:
        print("yes")
        sys.exit()

    # The following solution uses a formula to 
    # determine whether all components can be connected
    all_total = 0
    all_free = 0
    sated = 0
    full = 0

    for fre, tot in ccs:
        all_total += tot
        all_free += fre
        if fre == 0 and tot == 0:
            sated += 1
        elif fre == 0:
            full += 1
    
    x = max(len(ccs) - 1 - full - int(all_free / 2), 0)
    
    # this is the formula which succintly states the neccessary
    # conditions for connecting everything
    if all_total >= 2 * (len(ccs) - 1) and \
            k >= x + (len(ccs) - 1) + full + 2 * sated:
        print("yes")
    else:
        print("no")



if __name__ == '__main__':
    main()
