#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

void yes() {
        cout << "Yes" << endl;
        exit(0);
}

void no() {
        cout << "No" << endl;
        exit(0);
}

struct server {
        int index{}, cap{};
        vector<int>* connections;

        operator int() {
                return index;
        }
};

struct component {
        int free{};
        int freeAble{};

        bool operator >(const component& b) const {
                if (b.freeAble == 1)
                        return false;
                if (freeAble == 1)
                        return true;
                if (free < b.free)
                        return true;
                if (b.free < free)
                        return false;
                return freeAble < b.freeAble;
        }

        int connect(component& a) {
                int res = 1;
                if (!freeAble || !a.freeAble)
                        no();
                if (!free) {
                        free += 2;
                        res++;
                }
                if (!a.free) {
                        a.free += 2;
                        res++;
                }
                free += a.free - 2;
                freeAble += a.freeAble - 2;
                return res;
        }
};

vector<component> f(vector<server>& servers) {
        vector<component> components;
        vector<bool> visited(servers.size());
        fill(visited.begin(), visited.end(), false);
        for (server s : servers) {
                if (visited[s]) {
                        continue;
                }
                int size{}, cap{}, con_size{};
                vector<server> stack;
                stack.push_back(s);
                while (stack.size()) {
                        server s = stack.back();
                        stack.pop_back();
                        if (visited[s]) {
                                continue;
                        }
                        size++;
                        int deg = static_cast<int>(s.connections->size());
                        con_size += deg;
                        cap += s.cap - deg;
                        visited[s] = true;
                        for (int i : *s.connections) {
                                if (!visited[i]) {
                                        stack.push_back(servers[i]);
                                }
                        }
                }
                components.push_back(component{cap, cap + 2 * (con_size / 2 - size + 1)});
        }
        return components;
}

int main() {
        int n, m, k;    cin >> n >> m >> k;
        if (n == 1) {
                yes();
        }
        vector<server> servers(200000);
        for (int i = 0; i < n; ++i) {
                cin >> servers[i].cap;
                servers[i].index = i;
                servers[i].connections = new vector<int>;
        }
        for (int i = 0; i < m; ++i) {
                int a, b;       cin >> a >> b;
                servers[a].connections->push_back(b);
                servers[b].connections->push_back(a);
        }
        // discover networks
        vector<component> components = f(servers);
        if (components.size() == 1) {
                yes();
        }
        priority_queue<component, vector<component>, greater<component>> comps;
        for (auto pair : components) {
                if (pair.free == 0 && pair.freeAble == 0) {
                        comps.push(component{ 1,1 });
                        comps.push(component{ 1,1 });
                        k--;
                }
                else {
                        comps.push(pair);
                }
        }
        // combine "networks"
        while (comps.size() > 1 && k) {
                auto c1 = comps.top();          comps.pop();
                auto c2 = comps.top();          comps.pop();
                k -= c1.connect(c2);
                comps.push(c1);
        }
        if (comps.size() > 1 || k < 0)
                no();
        yes();
}
