#include <cstdio>
#include <vector>
#include <unordered_set>
typedef std::unordered_set<int> hashset;

inline bool contains(const hashset &set, int f){
	return set.find(f) != set.end();
}

int main(){
	int ninstruments, notes;
	scanf("%d %d", &ninstruments, &notes);
	std::vector<hashset> instruments(ninstruments, hashset());

	for(int i = 0; i < ninstruments; i++){
		int k;
		scanf("%d", &k);
		while(k--){
			int ins;
			scanf("%d", &ins);
			instruments[i].insert(ins);
		}
	}

	std::vector<int> song(notes);
	for(int i = 0; i < notes; i++){
		scanf("%d", &song[i]);
	}

	int l = 0, switches = -1;
	while(l < notes){
		int best = 0;
		for(const hashset &instr : instruments){
			int cnt = 0;
			for(int i = l; i < notes; i++){
				if(contains(instr, song[i])){
					cnt++;
				}
				else
					break;
			}
			best = cnt > best ? cnt : best;
		}
		l += best;
		switches++;
	}
	printf("%d\n", switches);
	return 0;
}
