import Test.QuickCheck
import Test.QuickCheck.Gen
import Test.QuickCheck.Random
import Control.Monad
import Data.List

caseGen :: Int -> Int -> Gen String
caseGen n var = do
    junks <- replicateM n $ choose (0, var)
    return . unlines $ map (unwords . map show) [[n], junks]

seed :: Int
seed = 123

cases :: [(Int, Int)]
cases = [(5, 5), (5, 10), (10, 100), (20, 10), (100, 50), (1000, 1000), (10000, 10000), (100000, 100000), (100000, 10^9), (100000, 10^9)]

formatNum :: Int -> String
formatNum n = replicate (2 - cs) '0' ++ show n
    where
        cs = length $ show n

solve :: String -> String
solve = (++"\n") . show . snd . head . sort . (`zip` [0..]) . map (read :: String -> Int) . tail . words

main :: IO ()
main = forM_ (zip [0..] cases) $ \(i, (n, var)) -> do
    let testCase = unGen (caseGen n var) (mkQCGen $ seed+i) (seed+i)
    writeFile ("data/secret/" ++ formatNum i ++ ".in") testCase
    writeFile ("data/secret/" ++ formatNum i ++ ".ans") (solve testCase)
    
    
    
